<template>
    <div
        v-if="data"
        class="w-full"
    >
        <div v-show="!secondStep">
            <Discount
                :data="data"
                @checkChanged="checkChanged"
            />
            <div class="discount-group edit__set_block">
                <div class="row">
                    <div class="col-md-4 form-title">
                        <b>Preview</b>
                    </div>
                    <div class="col-md-8 text-right">
                        <b-select
                            v-model="selectedTagMenu"
                            class="form-control select-tags"
                            @change="addText"
                        >
                            <option
                                v-for="(menu, index) in previewTags"
                                :key="index"
                                :disabled="menu.disabled"
                                :value="menu.title"
                            >
                                {{ menu.title }}
                            </option>
                        </b-select>
                    </div>
                </div>
                <validation-provider
                    v-slot="validationContext"
                    name="Subject"
                    :rules="{ required: true }"
                >
                    <b-form-group class="full-width">
                        <div class="form-content-title">
                            <b>Subject</b>
                        </div>
                        <b-form-input
                            v-model="data.subject"
                            type="text"
                            name="subject"
                            :state="getValidationState(validationContext)"
                            class="my-input full-width"
                            @click="focus"
                            @blur="checkChanged"
                        />
                        <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                    </b-form-group>
                </validation-provider>
                <validation-provider
                    v-slot="validationContext"
                    name="Email Preview"
                    :rules="{ required: true }"
                >
                    <b-form-group class="full-width">
                        <div class="form-content-title">
                            <b>Email Preview</b>
                        </div>
                        <b-form-input
                            v-model="data.pre_header"
                            type="text"
                            class="my-input full-width"
                            name="pre_header"
                            :state="getValidationState(validationContext)"
                            @click="focus"
                            @blur="checkChanged"
                        />
                        <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                    </b-form-group>
                </validation-provider>
            </div>
            <div class="discount-group edit__set_block">
                <div class="row">
                    <div class="col-md-4 form-title">
                        <b>Email Content</b>
                    </div>
                    <div class="col-md-8 text-right">
                        <b-select
                            v-model="selectedTagMenu"
                            class="form-control select-tags"
                            @change="addText"
                        >
                            <option
                                v-for="(menu, index) in tags"
                                :key="index"
                                :disabled="menu.disabled"
                                :value="menu.title"
                            >
                                {{ menu.title }}
                            </option>
                        </b-select>
                    </div>
                </div>
                <validation-provider
                    v-slot="validationContext"
                    name="Header"
                    :rules="{ required: true }"
                >
                    <b-form-group class="full-width">
                        <div class="form-content-title">
                            <b>Header</b>
                        </div>
                        <b-form-input
                            v-model="data.title"
                            type="text"
                            class="my-input full-width"
                            name="title"
                            :state="getValidationState(validationContext)"
                            @click="focus"
                            @blur="checkChanged"
                        />
                        <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                    </b-form-group>
                </validation-provider>
                <validation-provider
                    v-slot="validationContext"
                    name="Top Cart Body Text"
                    :rules="{ required: true }"
                >
                    <b-form-group class="full-width">
                        <div class="form-content-title">
                            <b>Top Cart Body Text</b>
                        </div>
                        <b-form-textarea
                            v-model="data.paragraph_1"
                            class="form-control full-width my-text-area"
                            name="paragraph_1"
                            :state="getValidationState(validationContext)"
                            @click="focus"
                        >
                            {{ data.paragraph_1 }}
                        </b-form-textarea>
                        <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                    </b-form-group>
                </validation-provider>
                <validation-provider
                    v-slot="validationContext"
                    name="Discount Banner Text"
                    :rules="{ required: true }"
                >
                    <b-form-group class="full-width">
                        <div class="form-content-title">
                            <b>Discount Banner Text</b>
                        </div>
                        <b-form-input
                            v-model="data.highlighted_text"
                            type="text"
                            class="my-input full-width"
                            name="highlighted_text"
                            :state="getValidationState(validationContext)"
                            @click="focus"
                            @blur="checkChanged"
                        />
                        <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                    </b-form-group>
                </validation-provider>
                <validation-provider
                    v-slot="validationContext"
                    name="Bottom Cart Body Text"
                    :rules="{ required: false }"
                >
                    <b-form-group class="full-width">
                        <div class="form-content-title">
                            <b>Bottom Cart Body Text</b>
                        </div>
                        <b-form-textarea
                            v-model="data.paragraph_2"
                            class="form-control full-width my-text-area"
                            name="paragraph_2"
                            :state="getValidationState(validationContext)"
                            @click="focus"
                        >
                            {{ data.paragraph_2 }}
                        </b-form-textarea>
                        <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                    </b-form-group>
                </validation-provider>
                <validation-provider
                    v-slot="validationContext"
                    name="Footer"
                    :rules="{ required: true }"
                >
                    <b-form-group class="full-width">
                        <div class="form-content-title">
                            <b>Footer</b>
                        </div>
                        <b-form-textarea
                            v-model="data.footer"
                            type="text"
                            class="my-input full-width my-text-area"
                            name="footer"
                            :state="getValidationState(validationContext)"
                            @click="focus"
                            @blur="checkChanged"
                        >
                            {{ data.footer }}
                        </b-form-textarea>
                        <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                    </b-form-group>
                </validation-provider>
                <validation-provider
                    v-slot="validationContext"
                    name="Footer"
                    :rules="{ required: true }"
                >
                    <b-form-group class="full-width">
                        <div class="form-content-title">
                            <b>Unsubscribe confirmation</b>
                        </div>
                        <b-form-textarea
                            v-model="data.unsubscribe_confirmation"
                            type="text"
                            class="full-width my-text-area"
                            name="Unsubscribe confirmation"
                            :state="getValidationState(validationContext)"
                            @click="focus"
                            @blur="checkChanged"
                        >
                            {{ data.unsubscribe_confirmation }}
                        </b-form-textarea>
                        <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                    </b-form-group>
                </validation-provider>

                <validation-provider
                    v-slot="validationContext"
                    name="URL"
                    :rules="{ required: true }"
                >
                    <b-form-group class="full-width">
                        <div class="form-content-title">
                            <b>URL</b>
                        </div>
                        <b-form-input
                            v-model="data.url"
                            type="text"
                            class="my-input full-width"
                            name="url"
                            :state="getValidationState(validationContext)"
                            @click="focus"
                            @blur="checkChanged"
                        />
                        <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                    </b-form-group>
                </validation-provider>
                <validation-provider
                    v-slot="validationContext"
                    name="Button Text"
                    :rules="{ required: true }"
                >
                    <b-form-group class="full-width">
                        <div class="form-content-title">
                            <b>Button Text</b>
                        </div>
                        <b-form-input
                            v-model="data.button_text"
                            type="text"
                            class="my-input full-width"
                            name="button_text"
                            :state="getValidationState(validationContext)"
                            @click="focus"
                            @blur="checkChanged"
                        />
                        <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                    </b-form-group>
                </validation-provider>
            </div>
        </div>
        <ScheduleStepCampaigns
            v-show="secondStep"
            :data="data"
            class="col-12"
            @checkChanged="checkChanged"
        />
    </div>
</template>

<script>
import { tags } from '@/mixins/add-tags.js'
import ScheduleStepCampaigns from "@/components/email/campaigns/ScheduleStepCampaigns";
import Discount from '@/components/edit/Discount.vue'; 
import {emailCampaignsTags, emailPreviewTags} from '@/store/constants.js'

export default {
    name: "TextEditorTabCampaigns",
    components: {
        ScheduleStepCampaigns,
        Discount
    },
    mixins: [tags],
    props: ['data', 'secondStep'],
    data: () => ({
        selectTypeMenus: [
            {
                title: 'Pre-made'
            },
            {
                title: 'Automatic'
            }
        ],
        tags: emailCampaignsTags,
        previewTags: emailPreviewTags,
        selectedTagMenu: 'tags',
        selectedTypeMenu: 'Pre-made',
        focusedInput: 0,
        focusedName: '',
    }),
    methods: {
        addText() {
            const data = this.addTag(this.data, this.focusedName, this.focusedInput, this.selectedTagMenu)

            if(data.keys.length > 1) this.data[data.keys[0]][data.keys[1]] = data.value
            else this.data[data.keys[0]] = data.value
            
            this.focusedInput += this.selectedTagMenu.length
            this.selectedTagMenu = 'tags'
        },
        checkChanged(key) {
            this.$emit('checkChanged', key)
        },
        focus(e) {
            this.focusedInput = e.target.selectionStart
            this.focusedName = e.target.name
        },
        getValidationState({dirty, validated, valid = null}) {
            return dirty || validated ? valid : null;
        },
    }
}
</script>

<style scoped lang="scss">

</style>
